%define build_root %(if [ ! -z ${build_root} ]; then echo ${build_root}; else echo "/var/tmp/IBGD"; fi)
%define STACK_PREFIX %(if [ ! -z ${STACK_PREFIX} ]; then echo ${STACK_PREFIX}; else echo "/usr/local/ibgd"; fi)
%define debug_package %{nil}
%define __check_files %{nil}

# Disable brp-lib64-linux
%ifarch x86_64 ia64
%define __arch_install_post %{nil}
%endif

# Name of package
%define base mpich_mlx

# Version of software
%define version 2.0.1

# rpm release
%define release 1

# Name of mpich channel device
%define device ch_vmi
%define mpi_tmpdir /tmp/ncsa_mpi

%define krelver %(echo $(uname -r) | tr -s '-' '_')

# Installation directory base prefix
%define name %{base}-%{device}

# Chose only one compiler
%define ccompiler gcc
%define fcompiler %(if [ ! -z ${PGF_77} ]; then echo ${PGF_77}; else echo "g77"; fi)
%define f90compiler %(if [ ! -z ${PGF_90} ]; then echo ${PGF_90}; else echo "g77"; fi)
%define cxxcompiler g++
%define flinker %(if [ ! -z ${PGF_77} ]; then echo ${PGF_77}; else echo "g77"; fi)

# Installation directory base prefix

# Do we want to enable building of the switcher module rpm? (1=yes 0=no)
%define yes_module 1
%define module_name %{base}-%{device}-%{ccompiler}-%{version}

#==============================================================

# Options for Module version:
# rpm -ba|--rebuild --define "module 1"
%{?module:%define yes_module 1}
%{?nomodule:%define yes_module 0}

#==============================================================

Summary: Portable Implementation of MPICH-VMI.
Name: %{name}
Version: %{version}
Release: %{krelver}
Packager: Malanox Technologies <http://www.mellanox.com>
URL: http://vmi.ncsa.uiuc.edu
Source: MPI125.tgz 
BuildRoot: %{build_root}
Copyright: Argonne National Labs (MPICH), NCSA(VMI)
Group: Applications/cluster
Requires: glibc 
Requires: vmi_mlx = %{version}
BuildArch: %{_target_cpu}

%description
MPICH-VMI2 is a freely available, portable implementation of MPI <http://www.mcs.anl.gov/mpi/index.html>, the Standard for message-passing libraries.

MPICH-VMI2 development tools (compilers, headers, libraries, examples)

#==============================================================

%package mpd
Summary: MPICH-VMI MPD Configuration files
Group: Applications/cluster
Requires: %{name}

%description mpd
MPICH-VMI2 MPD configuration files

#==============================================================

%prep

%setup -q -n MPI125

tar -zxf ${RPM_SOURCE_DIR}/PMB2.2.1.tar.gz
tar -zxf ${RPM_SOURCE_DIR}/osu-tests.tar.gz
tar -zxf ${RPM_SOURCE_DIR}/presta1.2.tgz

%install
./install-mpich.sh --build_root $RPM_BUILD_ROOT --prefix %{STACK_PREFIX} \
	--cc %{ccompiler} --fc %{fcompiler} --f90 %{f90compiler} --cxx %{cxxcompiler} 
%clean
\rm -rf ${RPM_BUILD_DIR}/MPI125

%preun

%post

%files
%{STACK_PREFIX}/mpi/ncsa/mpich-vmi-2.0.1
%config /etc/mpd.conf
%config /etc/init.d/mpd
# Tests
%{STACK_PREFIX}/mpi/ncsa/tests
#==============================================================

%changelog
* Wed Aug 4 2004 Pavel Shamis <pasha@mellanox.co.il>
- Initial packaging
