%define build_root %(if [ ! -z ${build_root} ]; then echo ${build_root}; else echo "/var/tmp/IBGD"; fi)
%define STACK_PREFIX %(if [ ! -z ${STACK_PREFIX} ]; then echo ${STACK_PREFIX}; else echo "/usr/local/ibgd"; fi)
%define fcompiler %(if [ ! -z ${PGF_77} ]; then echo ${PGF_77}; else echo "g77"; fi)
%define debug_package %{nil}
%define __check_files %{nil}

# Disable brp-lib64-linux
%ifarch x86_64 ia64
%define __arch_install_post %{nil}
%endif

Summary: Argonne National Laboratory MPI implementation
Name: mpich_mlx
Vendor: Argonne National Laboratory
Packager: Mellanox Technologies http://www.mellanox.com
Copyright: BSD-like
Group: System Environment/Libraries 
URL: http://www.mcs.anl.gov/mpi/mpich/

%define krelver %(echo $(uname -r) | tr -s '-' '_')

# Define the release value; this will be used, along with the compiler
# choice, to specify an actual Release name
%define release 1

#
# Set update_paths to 1 when building an RPM for distribution.  Set it
# to 0 when building a test RPM that you want to tryout when a BUILDRROOT
# is specified (if update_paths is 1, then the MPICH commands that need
# to know the file locations are edited to remove the BUILDROOT).
%define update_paths 1

Version: 0.9.4
Release: %{krelver}
Source0: mvapich-%{version}.tar.gz
Source1: mvapich-0.9.4_complib.patch.gz
Source2: mvapich-0.9.4_patch_101.gz
Source3: mvapich-0.9.4_patch_102.gz
Source4: mvapich-0.9.4_patch_103.gz
Source5: mvapich-0.9.4_patch_104.gz
Source6: mvapich-0.9.4_patch_106.gz
Source7: mvapich-0.9.4_patch_107.gz
Source8: mvapich-0.9.4_patch_108.gz
Source9: mvapich-0.9.4_mcst.patch.gz
Source10: mvapich-0.9.4_np_param.patch.gz
Source11: mvapich-0.9.4_mcst_leave.patch.gz
Source12: mvapich-0.9.4_SG_receive.patch.gz
Source13: PMB2.2.1.tar.gz
Source14: osu-tests.tar.gz
Source15: presta1.2.tgz
BuildRoot: %{build_root}
Provides: libmpich.so.1

%description 
MPICH is an open-source and portable implementation of the Message-Passing
Interface (MPI, www.mpi-forum.org).  MPI is a library for parallel programming,
and is available on a wide range of parallel machines, from single laptops to
massively parallel vector parallel processors.  
MPICH includes all of the routines in MPI 1.2, along with the I/O routines
from MPI-2 and some additional routines from MPI-2, including those supporting
MPI Info and some of the additional datatype constructors.  MPICH  was
developed by Argonne National Laboratory. See www.mcs.anl.gov/mpi/mpich for
more information.

%prep
%setup -q -n mvapich-%{version}
gzip -cdf ${RPM_SOURCE_DIR}/mvapich-0.9.4_complib.patch.gz > $RPM_BUILD_DIR/mvapich-%{version}/mvapich-0.9.4_complib.patch
gzip -cdf ${RPM_SOURCE_DIR}/mvapich-0.9.4_patch_101.gz > $RPM_BUILD_DIR/mvapich-%{version}/mvapich-0.9.4_patch_101
gzip -cdf ${RPM_SOURCE_DIR}/mvapich-0.9.4_patch_102.gz > $RPM_BUILD_DIR/mvapich-%{version}/mvapich-0.9.4_patch_102
gzip -cdf ${RPM_SOURCE_DIR}/mvapich-0.9.4_patch_103.gz > $RPM_BUILD_DIR/mvapich-%{version}/mvapich-0.9.4_patch_103
gzip -cdf ${RPM_SOURCE_DIR}/mvapich-0.9.4_patch_104.gz > $RPM_BUILD_DIR/mvapich-%{version}/mvapich-0.9.4_patch_104
gzip -cdf ${RPM_SOURCE_DIR}/mvapich-0.9.4_patch_106.gz > $RPM_BUILD_DIR/mvapich-%{version}/mvapich-0.9.4_patch_106
gzip -cdf ${RPM_SOURCE_DIR}/mvapich-0.9.4_patch_107.gz > $RPM_BUILD_DIR/mvapich-%{version}/mvapich-0.9.4_patch_107
gzip -cdf ${RPM_SOURCE_DIR}/mvapich-0.9.4_patch_108.gz > $RPM_BUILD_DIR/mvapich-%{version}/mvapich-0.9.4_patch_108
gzip -cdf ${RPM_SOURCE_DIR}/mvapich-0.9.4_mcst.patch.gz > $RPM_BUILD_DIR/mvapich-%{version}/mvapich-0.9.4_mcst.patch
gzip -cdf ${RPM_SOURCE_DIR}/mvapich-0.9.4_np_param.patch.gz > $RPM_BUILD_DIR/mvapich-%{version}/mvapich-0.9.4_np_param.patch
gzip -cdf ${RPM_SOURCE_DIR}/mvapich-0.9.4_mcst_leave.patch.gz > $RPM_BUILD_DIR/mvapich-%{version}/mvapich-0.9.4_mcst_leave.patch
gzip -cdf ${RPM_SOURCE_DIR}/mvapich-0.9.4_SG_receive.patch.gz > $RPM_BUILD_DIR/mvapich-%{version}/mvapich-0.9.4_SG_receive.patch

# PALLAS test
tar -zxf ${RPM_SOURCE_DIR}/PMB2.2.1.tar.gz

# osu-tests test
tar -zxf ${RPM_SOURCE_DIR}/osu-tests.tar.gz

# presta test
tar -zxf ${RPM_SOURCE_DIR}/presta1.2.tgz

%install
./install-mvapich.sh --build_root $RPM_BUILD_ROOT --prefix %{STACK_PREFIX} \
        --fc %{fcompiler}

%post	-p /sbin/ldconfig

%postun -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_DIR/mvapich-%{version}

%files
%defattr(-,root,root)
#%doc README COPYRIGHT doc/mpichman-chp4.ps.gz doc/mpichman-chp4mpd.ps.gz
#%doc doc/mpichman-chshmem.ps.gz doc/mpeman.ps.gz 
#%doc doc/mpeman.pdf doc/mpiman.ps
#%doc doc/mpichman-chp4.pdf doc/mpichman-chp4mpd.pdf 
#%doc doc/mpichman-chshmem.pdf 
#%doc doc/mpichman-globus2.pdf doc/mpichman-globus2.ps.gz
#%doc CHANGES.mvapich COPYRIGHT_MVAPICH CREDITS.mvapich 
#%doc LICENSE.TXT README_MPICH KnownBugs
#%doc mvapich.tuning_guide mvapich.user_guide
#%doc mpid/vapi/COPYRIGHT_MVICH mpid/vapi/CREDITS.mvich 
#%doc mpid/vapi/MVICH_LICENSE.TXT mpid/vapi/README_MVICH
%{STACK_PREFIX}/mpi/osu/mvapich-0.9.4

# PALLAS
%dir %{STACK_PREFIX}/mpi/osu/tests
%{STACK_PREFIX}/mpi/osu/tests/PMB2.2.1
# osu-tests
%{STACK_PREFIX}/mpi/osu/tests/osu-tests
# presta test
%{STACK_PREFIX}/mpi/osu/tests/presta1.2

