#!/bin/bash

usage()
{
   cat <<END
USAGE 
   install_mlxpart [--help] |
   install_mlxpart <dest_ip> [image]
END
}

if [ -z "$1" ] ; then 
   usage
   exit 1
fi

case "$1" in
    --help)
      usage
      exit 0
        ;;
    -*)
      usage
      exit 0
esac

dest_ip=$1

# Check access to target
ping $dest_ip -c 1 -w 1 > /dev/null 2>&1 || echo "Destination Host($dest_ip) Unreachable" || exit 2

if [ -z "$2" ] ; then
   image="`dirname $0`/image.tgz"
else
   image=$2
fi

# Check image
if [ ! -e $image ] ; then
   echo "Image file $image not found"
   exit 3
fi

###
### Start Install
###           
cat <<SS

   Starting installation of Mellanox tools partition
   
   If you have not arranged ssh access without password 
   you will be asked to enter destination host root password 
   several times during installation procedure.
   To arrange ssh without password follow the instructions 
   in README file.
   
   
SS
		      
echo "unzip image ..." 		   
gzip -dc $image > /tmp/image.tar  	|| exit 4

echo "Transfering image file to destination host ..."
scp /tmp/image.tar $dest_ip:/tmp/	|| exit 5

echo "Extracting image file. This will take few minutes ..."
ssh $dest_ip "tar -xv -f /tmp/image.tar -C /usr/mellanox ; rm /tmp/image.tar" &
sleep 10 
while ps | grep ssh > /dev/null ; do
   echo -en "\r|"  ; usleep 200000
   echo -en "\r/"  ; usleep 200000
   echo -en "\r-"  ; usleep 200000
   echo -en "\r\\" ; 
done   

echo " "
echo						    
echo "Installation of mellanox tools partition finished"
echo
 


