%define build_root %(if [ ! -z ${build_root} ]; then echo ${build_root}; else echo "/var/tmp/IBGD"; fi)
%define kunamer %(uname -r)
%define MTHOME %(if [ ! -z ${MTHOME} ]; then echo ${MTHOME}; else echo "%{build_root}/lib/modules/%{kunamer}/build/drivers/infiniband/hw/mellanox-hca"; fi)
%define TSHOME %(if [ ! -z ${TSHOME} ]; then echo ${TSHOME}; else echo "%{build_root}/lib/modules/%{kunamer}/build/drivers/infiniband/include"; fi)
%define OSMHOME %(if [ ! -z ${OSMHOME} ]; then echo ${OSMHOME}; else echo "/usr/local/ibgd/apps/osm"; fi)
%define VENDOR %(if [ ! -z ${VENDOR} ]; then echo ${VENDOR}; else echo "ts"; fi)
%define VERSION XXXXXX
%define NAME YYYYYY
%define RELVER ZZZZZZ
%define krelver %(echo $(uname -r) | tr -s '-' '_')
%if %(echo -n %{kunamer}| grep -c smp)
 %{expand:%%define ksmp -smp}
%endif

# Disable debugging
%define debug_package %{nil}
%define __check_files %{nil}

# Disable brp-lib64-linux
%ifarch x86_64 ia64
%define __arch_install_post %{nil}
%endif

Summary: InfiniBand Subnet Manager
BuildRequires: glib glib-devel glibc glibc-devel readline readline-devel
Prereq: grep
Requires: glib glibc readline openib
Name: %{NAME}
Version: %{VERSION}
Release: %{krelver}
Copyright: GPL
Group: System Environment/Base
Source: %{NAME}-%{RELVER}.tgz
BuildRoot: %{build_root}
Vendor: Mellanox Technologies Ltd.
AutoReq: no

%ifarch x86_64 ia64
Provides: libcomplib.so()(64bit) libosmsvc_ts.so()(64bit)
%else
Provides: libcomplib.so libosmsvc_ts.so
%endif

%description
Infiniband Subnet Manager

%prep
%setup -n %{NAME}-%{RELVER}

%install

#Install opensm
env TSHOME=%{TSHOME} MTHOME=%{MTHOME} $RPM_BUILD_DIR/%{NAME}-%{RELVER}/install.sh --build_root $RPM_BUILD_ROOT --prefix %{OSMHOME} -v %{VENDOR} -t $RPM_BUILD_ROOT/tmp/osm --build_only --batch
install -m 0644 $RPM_BUILD_DIR/%{NAME}-%{RELVER}/BUILD_ID $RPM_BUILD_ROOT/%{OSMHOME}

# Copy OpenSM sources
cd $RPM_BUILD_DIR/%{NAME}-%{RELVER}
tar xzvf $RPM_BUILD_DIR/%{NAME}-%{RELVER}/osm-linux.tgz > /dev/null
cp -rf $RPM_BUILD_DIR/%{NAME}-%{RELVER}/osm $RPM_BUILD_ROOT/%{OSMHOME}/src

install -d $RPM_BUILD_ROOT/etc/init.d
install -m 0644 $RPM_BUILD_DIR/%{NAME}-%{RELVER}/opensm.conf $RPM_BUILD_ROOT/etc/opensm.conf
install -m 0755 $RPM_BUILD_DIR/%{NAME}-%{RELVER}/opensmd $RPM_BUILD_ROOT/etc/init.d/opensmd

install -d $RPM_BUILD_ROOT/usr/bin
##############################################################
# we need to use the corrrect libraries based on the machine #
# use 64 bit libs if needed				                     #
##############################################################

if test -d /lib64/tls -o -d /lib/tls; then
   ptl_path=`gcc -print-file-name=libpthread.so|sed s=[^/]*$==`
   if test -z `file $ptl_path/libpthread.so|grep "text"|wc -l`; then
       ptl_file=`cd $ptl_path;pwd`/libpthread.so
   else
       ptl_file=`awk '/GROUP/{print $3}' $ptl_path/libpthread.so`
   fi
   glibc_path=`gcc -print-file-name=libc.so|sed s=[^/]*$==`
   if test -z `file $glibc_path/libc.so|grep "text"|wc -l`; then
      glibc_file=`cd $glibc_path;pwd`/libc.so
   else
      glibc_file=`awk '/GROUP/{print $3}' $glibc_path/libc.so`
   fi
     echo "-I- Need to preload to avoid /lib/tls"
     cat > $RPM_BUILD_ROOT/usr/bin/opensm <<EOF
#!/bin/sh -f
export LD_PRELOAD=$glibc_file:$ptl_file
%{OSMHOME}/bin/opensm \$@
EOF
     cat > $RPM_BUILD_ROOT/usr/bin/osmtest <<EOF
#!/bin/sh -f
export LD_PRELOAD=$glibc_file:$ptl_file
%{OSMHOME}/bin/osmtest \$@
EOF
   chmod 755 $RPM_BUILD_ROOT/usr/bin/osmtest $RPM_BUILD_ROOT/usr/bin/opensm
else
	install -m 0755 $RPM_BUILD_ROOT/%{OSMHOME}/bin/osmtest $RPM_BUILD_ROOT/usr/bin/osmtest 
	install -m 0755 $RPM_BUILD_ROOT/%{OSMHOME}/bin/opensm $RPM_BUILD_ROOT/usr/bin/opensm
fi

##############################################################


## Install ibrd daemon
#cd $RPM_BUILD_DIR/%{NAME}-%{RELVER}/ibrd
#
#env ib_prefix=%{MTHOME} osm_prefix=%{OSMHOME} ./configure
#make
#install -m 0755 $RPM_BUILD_DIR/%{NAME}-%{RELVER}/ibrd/ibrd %{OSMHOME}/bin/ibrd
#
#
#cd -

%clean
rm -rf $RPM_BUILD_DIR/%{NAME}-%{RELVER}

%pre
	
%post
if [ $1 = 1 ]; then #This package is being installed for the first time

	if [ `uname -r` != "%{kunamer}" ]; then
	   echo This rpm supports only %{kunamer} kernel...
	   rpm -e %{NAME} 
	else

#	if [ -d %{OSMHOME}/bin ]; then	
#           cd /usr/bin
#           for bin in %{OSMHOME}/bin/*
#           do
#             ln -s -f ${bin}
#           done
#           cd -
#	fi

       	#add library path to system (as first choice)
        grep %{OSMHOME}/lib /etc/ld.so.conf > /dev/null 2>&1
        if [ $? == 1 ]; then
        #   Modifying ld.so.conf (System libraries cache):
        #   Copy original ld.so.conf to /etc/ld.so.conf.OSMbackup...
           mv -f /etc/ld.so.conf /etc/ld.so.conf.OSMbackup 
           echo %{OSMHOME}/lib > /etc/ld.so.conf
           cat /etc/ld.so.conf.OSMbackup >> /etc/ld.so.conf
        fi   
        /sbin/ldconfig
	
#	# Add ibrd daemon to the inittab
#	echo "ib0:345:respawn:%{OSMHOME}/bin/ibrd -p 1 > /dev/null 2>&1" >> /etc/inittab
#	echo "ib1:345:respawn:%{OSMHOME}/bin/ibrd -p 2 > /dev/null 2>&1" >> /etc/inittab


# Use saved configuration files if exists (rpmsave)
CONFIGS="/etc/opensm.conf"
for conf in $CONFIGS
do
    if [ -e ${conf}.rpmsave ]; then
	[ -e ${conf} ] && cp -f ${conf} ${conf}.rpmnew
        cp -f ${conf}.rpmsave ${conf}
    fi    
done	

if [[ -f /etc/redhat-release || -f /etc/rocks-release ]]; then        
        /sbin/chkconfig --del opensmd
        /sbin/chkconfig --add opensmd
fi

if [ -f /etc/SuSE-release ]; then
        /sbin/insserv opensmd
fi

	fi
fi	
	
%files
%defattr(-,root,root)
%dir %{OSMHOME}
%{OSMHOME}/bin
%{OSMHOME}/include
%{OSMHOME}/lib
%{OSMHOME}/src
%{OSMHOME}/BUILD_ID
%config /etc/opensm.conf
/etc/init.d/opensmd
/usr/bin/opensm
/usr/bin/osmtest

%preun
   if [[ -f /etc/redhat-release || -f /etc/rocks-release ]]; then        
        /sbin/chkconfig --del opensmd 
   fi
   if [ -f /etc/SuSE-release ]; then
        /sbin/insserv -r opensmd
   fi

# if [ $1 = 0 ]; then  # Erase, not upgrade
#
#    if [ -d %{OSMHOME}/bin ]; then
#      cd %{OSMHOME}/bin
#      for bin in *
#      do
#         [ "$bin" != "*" ] && rm -f /usr/bin/$bin
#      done
#      cd -
#    fi
# fi
 
%postun
if [ $1 = 0 ]; then # Erase, not upgrade
   if (grep -v %{OSMHOME} /etc/ld.so.conf > /tmp/tmp.opensm); then
        mv -f /tmp/tmp.opensm /etc/ld.so.conf
   fi
   /sbin/ldconfig
   
#   if (grep -v %{OSMHOME}/bin/ibrd /etc/inittab > /tmp/tmp.inittab); then
#	mv -f /tmp/tmp.inittab /etc/inittab
#   fi
fi

%changelog
* Tue Jul 27 2004 Vladimir Sokolovsky <vlad@mellanox.co.il>
- Initial packaging for OpenIB stack
